/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: echo.h,v 1.3 2006/02/07 10:12:14 abe Exp abe $
 */

#ifndef _ECHO_H_
#define _ECHO_H_

/* 
 *  ECHO 饤ȡФΥå
 */

#if defined(H8)

#define TCP_ECHO_SRV_STACK_SIZE		1024		/* TCP ECHO ХΥå		*/
#define TCP_ECHO_CLI_RCV_STACK_SIZE	1024		/* TCP ECHO 饤ȼΥå	*/
#define TCP_ECHO_CLI_SND_STACK_SIZE	1024		/* TCP ECHO 饤Υå	*/

#else	/* of #if defined(H8) */

#define TCP_ECHO_SRV_STACK_SIZE		(1024*2)	/* TCP ECHO ХΥå		*/
#define TCP_ECHO_CLI_RCV_STACK_SIZE	(1024*2)	/* TCP ECHO 饤ȼΥå	*/
#define TCP_ECHO_CLI_SND_STACK_SIZE	(1024*2)	/* TCP ECHO 饤Υå	*/

#endif	/* of #if defined(H8) */

#define UDP_ECHO_SRV_STACK_SIZE		1024		/* UDP ECHO ХΥå		*/
#define UDP_ECHO_CLI_STACK_SIZE		1024		/* UDP ECHO 饤ȥΥå	*/

/* 
 *  ECHO 饤ȡФͥ
 */

#define TCP_ECHO_SRV_MAIN_PRIORITY	5		/* TCP ECHO Хͥ			*/
#define TCP_ECHO_CLI_RCV_MAIN_PRIORITY	5		/* TCP ECHO 饤ȼͥ		*/
#define TCP_ECHO_CLI_SND_MAIN_PRIORITY	5		/* TCP ECHO 饤ͥ		*/

#define UDP_ECHO_SRV_MAIN_PRIORITY	5		/* UDP ECHO Хͥ			*/
#define UDP_ECHO_CLI_MAIN_PRIORITY	5		/* UDP ECHO 饤ȥͥ		*/

/* ECHO 塼 */

#define NUM_DTQ_UDP_ECHO_CLI	2	/* UDP ECHO 塼	*/
#define NUM_DTQ_TCP_ECHO_CLI	2	/* TCP ECHO 塼	*/

/*
 *  TCP ɥХåե
 */

#if defined(NUM_MPF_NET_BUF_IF_PDU) && NUM_MPF_NET_BUF_IF_PDU > 0

#define TCP_ECHO_CLI_SWBUF_SIZE	(1024*2)
#define TCP_ECHO_CLI_RWBUF_SIZE	(1024*2)

#define TCP_ECHO_SRV_SWBUF_SIZE	(1024*2)
#define TCP_ECHO_SRV_RWBUF_SIZE	(1024*2)

#else	/* of #if defined(NUM_MPF_NET_BUF_IF_PDU) && NUM_MPF_NET_BUF_IF_PDU > 0 */

#ifdef SUPPORT_INET4

#define TCP_ECHO_CLI_SWBUF_SIZE	(TCP_MSS)
#define TCP_ECHO_CLI_RWBUF_SIZE	(TCP_MSS)

#define TCP_ECHO_SRV_SWBUF_SIZE	(TCP_MSS)
#define TCP_ECHO_SRV_RWBUF_SIZE	(TCP_MSS)

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

#define TCP_ECHO_CLI_SWBUF_SIZE	(TCP6_MSS)
#define TCP_ECHO_CLI_RWBUF_SIZE	(TCP6_MSS)

#define TCP_ECHO_SRV_SWBUF_SIZE	(TCP6_MSS)
#define TCP_ECHO_SRV_RWBUF_SIZE	(TCP6_MSS)

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #if defined(NUM_MPF_NET_BUF_IF_PDU) && NUM_MPF_NET_BUF_IF_PDU > 0 */

/*
 *  ѿ
 */

extern BOOL	tcp_echo_cli_valid;

/*
 *  
 */

extern void	tcp_echo_srv_task(VP_INT exinf);
extern void	tcp_echo_srv_rcv_task(VP_INT exinf);
extern void	tcp_echo_srv_snd_task(VP_INT exinf);
extern void	tcp_echo_cli_rcv_task(VP_INT exinf);
extern void	tcp_echo_cli_snd_task(VP_INT exinf);

extern void	udp_echo_srv_task(VP_INT exinf);
extern void	udp_echo_cli_task(VP_INT exinf);

/*
 *  ؿ
 */

extern ER callback_nblk_tcp_echo_srv (ID cepid, FN fncd, VP p_parblk);
extern ER callback_nblk_tcp_echo_cli (ID cepid, FN fncd, VP p_parblk);

extern ER callback_udp_echo_srv (ID cepid, FN fncd, VP p_parblk);
extern ER callback_udp_echo_cli (ID cepid, FN fncd, VP p_parblk);

extern ER callback_nblk_udp_echo_srv (ID cepid, FN fncd, VP p_parblk);
extern ER callback_nblk_udp_echo_cli (ID cepid, FN fncd, VP p_parblk);

#endif	/* of #ifndef _ECHO_H_ */
